c     Copyright (C) 2008-2009 Vincent Eymet
c
c     KDISTRIBUTION is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 3, or (at your option)
c     any later version.

c     KDISTRIBUTION is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with KDISTRIBUTION; if not, see <http://www.gnu.org/licenses/>
c
      program main
      implicit none

      include 'max.inc'
      include 'formats.inc'
      include 'mpif.h'
      integer strlen
      integer kind,kpts,i,Nb,band,imin,quad,Nq,m,ns
      integer Np,nk,i_min,i_max,nl,valid,ik,mol
      double precision alt(1:Nmax)
      double precision pres(1:Nmax)
      double precision temp(1:Nmax)
      double precision x(1:Nmax,1:Nmol_max)
c     Debug
c      integer ik,jk,nki
c      double precision nut,S
c     Debug
      double precision eps1,eps2
      double precision alpha,beta,b(Nqmx)
      double precision endpts(2),fixed_g(2)
c      double precision t(Nqmx)
c      double precision w1(Nqmx)
      double precision g(Nqmx)
      double precision w(Nqmx)
      double precision sum_w
      double precision nu_min(1:Nbmx),nu_max(1:Nbmx)
      double precision nu(1:kmax),k(1:kmax)
      double precision z(1:kmax)
      double precision k_min,k_max
      double precision gac(0:Npmax),kac(0:Npmax)
      double precision epsilon,raf
      integer sit
      double precision err(1:Nmax,1:Nbmx,1:Nqmx)
      double precision kdist(1:Nmax,1:Nbmx,1:Nqmx)
      double precision delta_k(1:Nmax,1:Nbmx,1:Nqmx)
      double precision tr_exact(1:Nmax,1:Nbmx)
      double precision tr_quad(1:Nmax,1:Nbmx)
      double precision tr_exactp(1:Nbmx)
      double precision tr_quadp(1:Nbmx)
      double precision tr_exact0(1:Nbmx)
      double precision tr_quad0(1:Nbmx)
      double precision kdistp(1:Nbmx,1:Nqmx)
      double precision delta_kp(1:Nbmx,1:Nqmx)
      double precision errp(1:Nbmx,1:Nqmx)
      double precision kdist0(1:Nbmx,1:Nqmx)
      double precision delta_k0(1:Nbmx,1:Nqmx)
      double precision err0(1:Nbmx,1:Nqmx)
      double precision g_step(1:Nsmx)
      character*100 kfile,base,pfile,quad_file
c     sensitivities
      double precision dk_dP(1:kmax)
      double precision dk_dT(1:kmax)
      double precision dk_dx(1:kmax,1:Nmol_max)
      double precision kP(1:kmax)
      double precision kT(1:kmax)
      double precision kx_tmp(1:kmax)
      double precision kx(1:kmax,1:Nmol_max)
      double precision dPtot(1:Nmax,1:Nbmx)
      double precision dTtot(1:Nmax,1:Nbmx)
      double precision dxtot(1:Nmax,1:Nbmx,1:Nmol_max)
      double precision dP0(1:Nbmx)
      double precision dT0(1:Nbmx)
      double precision dx0_tmp(1:Nmol_max)
      double precision dx0(1:Nbmx,1:Nmol_max)
      double precision dP(1:Nbmx)
      double precision dT(1:Nbmx)
      double precision dx_tmp(1:Nmol_max)
      double precision dx(1:Nbmx,1:Nmol_max)
      double precision zP(1:kmax)
      double precision zT(1:kmax)
      double precision zx_tmp(1:kmax)
      double precision zx(1:kmax,1:Nmol_max)
      double precision k_minP,k_maxP
      double precision k_minT,k_maxT
      double precision k_minx(1:Nmol_max),k_maxx(1:Nmol_max)
      double precision gacP(0:Npmax),kacP(0:Npmax)
      double precision gacT(0:Npmax),kacT(0:Npmax)
      double precision gacx_tmp(0:Npmax),kacx_tmp(0:Npmax)
      double precision gacx(0:Npmax,1:Nmol_max)
      double precision kacx(0:Npmax,1:Nmol_max)
      double precision kdistPres(1:Nmax,1:Nbmx,1:Nqmx)
      double precision kdistTemp(1:Nmax,1:Nbmx,1:Nqmx)
      double precision kdistxspecies(1:Nmax,1:Nbmx,1:Nqmx,1:Nmol_max)
      double precision kdistpP(1:Nbmx,1:Nqmx)
      double precision kdistpT(1:Nbmx,1:Nqmx)
      double precision kdistpx(1:Nbmx,1:Nqmx,1:Nmol_max)
      double precision delta_kpP(1:Nbmx,1:Nqmx)
      double precision delta_kpT(1:Nbmx,1:Nqmx)
      double precision delta_kpx(1:Nbmx,1:Nqmx,1:Nmol_max)
      double precision errpP(1:Nbmx,1:Nqmx)
      double precision errpT(1:Nbmx,1:Nqmx)
      double precision errpx(1:Nbmx,1:Nqmx,1:Nmol_max)
      double precision kdistP0(1:Nbmx,1:Nqmx)
      double precision kdistT0(1:Nbmx,1:Nqmx)
      double precision kdistx0(1:Nbmx,1:Nqmx,1:Nmol_max)
      character*100 dkdP_file,dkdT_file,dkdx_file
c     sensitivities

c     atmospheric data
c      double precision alt(1:Nmax)
c      double precision pres(1:Nmax)
c      double precision temp(1:Nmax)
c      double precision Tsol
c      double precision Tesp
c     atmospheric data
c      double precision kspectrum(1:kmax,2)
c      double precision dkdP_spectrum(1:kmax)
c      double precision dkdT_spectrum(1:kmax)
c      double precision dkdx_spectrum(1:kmax,1:Nmol_max)
      integer Nmol
c     MPI
      integer ierr,errorcode,nproc,pindex
      integer stat(MPI_STATUS_SIZE)
      integer chunk,nchunks
      integer code0,codep
      integer proc,fin,fpf,nsp
      integer free(1:Nproc_mx)
      integer ch_idx(1:Nproc_mx)
c     MPI
      character*100 label
      label='main'


c     MPICH
      call MPI_INIT(ierr)
      if (ierr.NE.MPI_SUCCESS) THEN
         write(*,*) 'Error from program ',
     &        label(1:strlen(label)),' :'
         write(*,*) 'MPI could not be initialized'
         call MPI_ABORT(MPI_COMM_WORLD,errorcode,ierr)
      endif
c     Get 'np', the number of processes
      call MPI_COMM_SIZE(MPI_COMM_WORLD,nproc,ierr)
      if (nproc.lt.2) then
         write(*,*) 'Error from program ',
     &        label(1:strlen(label)),' :'
         write(*,*) 'Number of processes is:',nproc
         write(*,*) 'and it should be greater than 1'
         stop
      endif
c     Get 'pindex', the index of the current process
      call MPI_COMM_RANK(MPI_COMM_WORLD,pindex,ierr)
c     MPICH

      if (pindex.eq.0) then     ! root process only
         write(*,*) 'KDISTRIBUTION Copyright (C) 2008-2009 V. Eymet'
         write(*,*) 'This program comes with ABSOLUTELY NO WARRANTY;'
         write(*,*) 'This is free software, and you are welcome to'//
     &        ' redistribute it'
         write(*,*) 'under certain conditions; see file "COPYING"'//
     &        ' for details.'
         write(*,*)

c     ********** FIRST STEP **************
c     production of quadrature abscissas and weights
c     

         base='./data/hires_spectrum'
         write(*,*) 'Production of quadrature abscissas and weights...'

c     Reading options
c     warning: only Legendre quadrature (kind=1 and kpts=0),
c     Radau (kind=1 and kpts=1) and Lobatto (kind=1 and kpts=2) are available
         call read_options(kind,kpts,Nq,fixed_g,alpha,beta,
     &        endpts,Np,epsilon,sit,quad_file)
         
         if (kind.eq.0) then
c     reading quadrature abscissas g(quad) and weights w(quad)
            open(10,file=quad_file(1:strlen(quad_file)))
            read(10,*)
            do quad=1,Nq
               read(10,*) g(quad),w(quad)
            enddo
            close(10)
         else
c     producing quadrature abscissas t(quad) and weights w1(quad)
            if (kind.eq.1) then ! Legendre
               call myquad(Nq,1,alpha,beta,g,w,valid)
            else if (kind.eq.2) then ! Legendre-Radau
               call myquad(Nq,2,alpha,beta,g,w,valid)
            else if (kind.eq.3) then ! Legendre-Lobatto
               call myquad(Nq,3,alpha,beta,g,w,valid)
            else if (kind.eq.4) then ! Chebyshev first kind
               call gaussq(2,Nq,alpha,beta,kpts,endpts,b,g,w)
            else if (kind.eq.5) then ! Chebyshev second kind
               call gaussq(3,Nq,alpha,beta,kpts,endpts,b,g,w)
            else if (kind.eq.6) then ! Hermite
               call gaussq(4,Nq,alpha,beta,kpts,endpts,b,g,w)
            else if (kind.eq.7) then ! Jacobi
               call myquad(Nq,4,alpha,beta,g,w,valid)
            else if (kind.eq.8) then ! Laguerre
               call gaussq(6,Nq,alpha,beta,kpts,endpts,b,g,w)
            endif
         endif

c     sort abscissas and weights by ascending order
         call sort_gw(Nq,g,w)
c     writing output information
         call write_quad_results(kpts,kind,Nq,fixed_g,g,w)

         write(*,*) '...done'
c     
c     ************************************



c     ********** SECOND STEP **************
c     Production of the k-distributions

         write(*,*) 'Production of k-distribution data set...'
c     looking for values of k(g(i))
         call read_model(m,Nmol,alt,pres,temp,x)
         call read_nu(Nb,nu_min,nu_max)
         call read_data(i_min,i_max)
         call look_for_errors(m,i_min,i_max)
         pfile=base(1:strlen(base))//'/calculation_info.txt'
         call read_eps12(pfile,eps1,eps2)
         
         nchunks=i_max-i_min+1
         code0=1                ! data transfer
         do proc=1,nproc-1
            call MPI_SEND(code0,1,MPI_INTEGER
     &           ,proc,1,MPI_COMM_WORLD,ierr)
         enddo
c     send integer data
         call MPI_BCAST(Nb,1,MPI_INTEGER
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(Nq,1,MPI_INTEGER
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(Np,1,MPI_INTEGER
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(Nmol,1,MPI_INTEGER
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(sit,1,MPI_INTEGER
     &        ,0,MPI_COMM_WORLD,ierr)
c     send double precision data
         call MPI_BCAST(epsilon,1,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(eps1,1,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(eps2,1,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(nu_min,Nbmx,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(nu_max,Nbmx,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(w,Nqmx,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(g,Nqmx,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(alt,Nmax,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(pres,Nmax,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(temp,Nmax,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(x,Nmax*Nmol_max,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         
         do proc=1,nproc-1
            free(proc)=1
         enddo
         nk=0
         fin=0
         chunk=0

         do while(fin.eq.0)
 444        continue
            call find_free_process(free,nproc-1,fpf,proc)
            if (fpf.eq.1) then  ! a free child process found
               chunk=chunk+1
               if (chunk.le.nchunks) then
                  ch_idx(proc)=chunk
                  code0=2
                  call MPI_SEND(code0,1,MPI_INTEGER
     &                 ,proc,1,MPI_COMM_WORLD,ierr)
                  i=i_min+chunk-1
                  call MPI_SEND(i,1,MPI_INTEGER,
     &                 proc,1,MPI_COMM_WORLD,ierr)
                  free(proc)=0  ! child process index 'proc' is busy
               else             ! chunk>nchunks
                  free(proc)=2  ! means child process index 'proc' has been stopped
               endif
               goto 444
            else                ! no free child process found
               call stopped_processes(free,nproc-1,nsp)
               if (nsp.eq.nproc-1) then
                  fin=1
                  goto 111
               endif
c     wait for results
               call MPI_RECV(proc,1,MPI_INTEGER
     &              ,MPI_ANY_SOURCE,MPI_ANY_TAG,MPI_COMM_WORLD,
     &              stat,ierr)
               call MPI_RECV(kdist0,Nbmx*Nqmx,MPI_DOUBLE_PRECISION
     &              ,proc,MPI_ANY_TAG,MPI_COMM_WORLD,stat,ierr)
               call MPI_RECV(delta_k0,Nbmx*Nqmx,MPI_DOUBLE_PRECISION
     &              ,proc,MPI_ANY_TAG,MPI_COMM_WORLD,stat,ierr)
               call MPI_RECV(err0,Nbmx*Nqmx,MPI_DOUBLE_PRECISION
     &              ,proc,MPI_ANY_TAG,MPI_COMM_WORLD,stat,ierr)
               call MPI_RECV(tr_exact0,Nbmx,MPI_DOUBLE_PRECISION
     &              ,proc,MPI_ANY_TAG,MPI_COMM_WORLD,stat,ierr)
               call MPI_RECV(tr_quad0,Nbmx,MPI_DOUBLE_PRECISION
     &              ,proc,MPI_ANY_TAG,MPI_COMM_WORLD,stat,ierr)
c     ----------------------------------------------------------------------
c     sensitivities
               call MPI_RECV(kdistP0,Nbmx*Nqmx,MPI_DOUBLE_PRECISION
     &              ,proc,MPI_ANY_TAG,MPI_COMM_WORLD,stat,ierr)
               call MPI_RECV(kdistT0,Nbmx*Nqmx,MPI_DOUBLE_PRECISION
     &              ,proc,MPI_ANY_TAG,MPI_COMM_WORLD,stat,ierr)
               call MPI_RECV(kdistx0,Nbmx*Nqmx*Nmol_max,
     &              MPI_DOUBLE_PRECISION
     &              ,proc,MPI_ANY_TAG,MPI_COMM_WORLD,stat,ierr)
               call MPI_RECV(dP0,Nbmx,MPI_DOUBLE_PRECISION
     &              ,proc,MPI_ANY_TAG,MPI_COMM_WORLD,stat,ierr)
               call MPI_RECV(dT0,Nbmx,MPI_DOUBLE_PRECISION
     &              ,proc,MPI_ANY_TAG,MPI_COMM_WORLD,stat,ierr)
               call MPI_RECV(dx0,Nbmx*Nmol_max,MPI_DOUBLE_PRECISION
     &              ,proc,MPI_ANY_TAG,MPI_COMM_WORLD,stat,ierr)
c     ----------------------------------------------------------------------
               free(proc)=1     ! child process index 'proc' is free again

               i=i_min+ch_idx(proc)-1
               do band=1,Nb
                  do quad=1,Nq
                     kdist(i,band,quad)=kdist0(band,quad)
                     delta_k(i,band,quad)=delta_k0(band,quad)
                     err(i,band,quad)=err0(band,quad)
c     ----------------------------------------------------------------------
c     sensitivities
                     kdistPres(i,band,quad)=kdistP0(band,quad)
                     kdistTemp(i,band,quad)=kdistT0(band,quad)
                     do mol=1,Nmol
                        kdistxspecies(i,band,quad,mol)=
     &                       kdistx0(band,quad,mol)
                     enddo ! mol
c     ----------------------------------------------------------------------
                  enddo ! quad
                  tr_exact(i,band)=tr_exact0(band)
                  tr_quad(i,band)=tr_quad0(band)
                  dPtot(i,band)=dP0(band)
                  dTtot(i,band)=dT0(band)
                  do mol=1,Nmol
                     dxtot(i,band,mol)=dx0(band,mol)
                  enddo         ! mol
               enddo ! band
               
            endif               ! fpf=0 or 1
 111        continue
         enddo                  ! while fin=0
c     stopping all child processes
         do proc=1,nproc-1
            code0=0
            call MPI_SEND(code0,1,MPI_INTEGER
     &           ,proc,1,MPI_COMM_WORLD,ierr)
         enddo ! proc

c     ************************************
c     writing output information
         call write_kdist_results(i_min,i_max,Nb,Nq,nu_min,nu_max,w,
     &        kdist,delta_k,tr_exact,tr_quad,
     &        kdistPres,kdistTemp,kdistxspecies,Nmol,
     &        dPtot,dTtot,dxtot)
         
         write(*,*) '...done'
c     
c     ************************************
         
         call clean()

      else                      ! child processes
         base='./data/hires_spectrum'
         
 333     continue
c     wait for "codep" from root process
         call MPI_RECV(codep,1,MPI_INTEGER
     &        ,0,MPI_ANY_TAG,MPI_COMM_WORLD,stat,ierr)
c     codep=0 means exit
         if (codep.eq.0) then
            goto 666
c     codep=1 means reception of data
         else if (codep.eq.1) then
c     send integer data
         call MPI_BCAST(Nb,1,MPI_INTEGER
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(Nq,1,MPI_INTEGER
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(Np,1,MPI_INTEGER
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(Nmol,1,MPI_INTEGER
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(sit,1,MPI_INTEGER
     &        ,0,MPI_COMM_WORLD,ierr)
c     send double precision data
         call MPI_BCAST(epsilon,1,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(eps1,1,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(eps2,1,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(nu_min,Nbmx,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(nu_max,Nbmx,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(w,Nqmx,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(g,Nqmx,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(alt,Nmax,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(pres,Nmax,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(temp,Nmax,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         call MPI_BCAST(x,Nmax*Nmol_max,
     &        MPI_DOUBLE_PRECISION
     &        ,0,MPI_COMM_WORLD,ierr)
         
c     codep=2 means a computation has to be performed
         else if (codep.eq.2) then
            call MPI_RECV(i,1,MPI_INTEGER
     &           ,0,MPI_ANY_TAG,MPI_COMM_WORLD,stat,ierr)
c     Debug
            write(*,*) 'Computation for interface',i
c     Debug
            call generate_kfile(base,i,kfile,
     &           dkdP_file,dkdT_file,dkdx_file)
c            call read_spectrum(kfile,dkdP_file,dkdT_file,dkdx_file,
c     &           pindex,kspectrum,nl,
c     &           dkdP_spectrum,dkdT_spectrum,dkdx_spectrum,Nmol)

            do band=1,Nb
c     Debug
               write(*,*) 'band=',band
c     Debug
c               call read_band(kspectrum,nl,band,
c     &              nu_min(band),nu_max(band),
c     &              dkdP_spectrum,dkdT_spectrum,dkdx_spectrum,Nmol,
c     &              imin,nk)
               if (nk.gt.kmax) then
                  write(*,*) 'Error from program ',
     &                 label(1:strlen(label)),' :'
                  write(*,*) 'nk=',nk,' while kmax=',kmax
                  write(*,*) 'interface:',i,' band:',band
                  stop
               endif
c               call read_ka(kspectrum,nl,imin,nk,
c     &              nu_min(band),nu_max(band),
c     &              dkdP_spectrum,dkdT_spectrum,dkdx_spectrum,Nmol,
c     &              nu,k,dk_dP,dk_dT,dk_dx)
               call read_single_kspectrum(kfile,
     &              dkdP_file,dkdT_file,dkdx_file,
     &              nu_min(band),nu_max(band),pindex,
     &              nk,nu,k,dk_dP,dk_dT,Nmol,dk_dx)
c     ----------------------------------------------------------------------
c     sensitivities
               call other_spectrum(nk,k,dk_dP,dk_dT,dk_dx,Nmol,
     &              i,pres,temp,x,
     &              kP,kT,kx,dP(band),dT(band),dx_tmp)
c     Debug
c               write(*,*) 'band=',band,' dT=',dT(band)
c               if (band.eq.2) then
c                  open(10,file='./verif.txt')
c                  do ik=1,nk
c                     write(10,50) nu(ik),k(ik),dk_dT(ik),kT(ik)
c                  enddo
c                  close(10)
c                  stop
c               endif
c     Debug
               do mol=1,Nmol
                  dx(band,mol)=dx_tmp(mol)
               enddo ! mol
c     ----------------------------------------------------------------------
               
               if (sit.ne.1) then
                  call cubic_spline(nk,nu,k,z,valid)
c     ----------------------------------------------------------------------
c     sensitivities
                  call cubic_spline(nk,nu,kP,zP,valid)
                  call cubic_spline(nk,nu,kT,zT,valid)
                  do mol=1,Nmol
                     do ik=1,kmax
                        kx_tmp(ik)=kx(ik,mol)
                     enddo ! ik
                     call cubic_spline(nk,nu,kx_tmp,zx_tmp,valid)
                     do ik=1,kmax
                        zx(ik,mol)=zx_tmp(ik)
                     enddo ! ik
                  enddo ! mol
c     ----------------------------------------------------------------------
               endif

               call minmax(nk,k,k_min,k_max)
c     ----------------------------------------------------------------------
c     sensitivities
               call minmax(nk,kP,k_minP,k_maxP)
               call minmax(nk,kT,k_minT,k_maxT)
               do mol=1,Nmol
                  do ik=1,kmax
                     kx_tmp(ik)=kx(ik,mol)
                  enddo ! ik
                  call minmax(nk,kx_tmp,k_minx(mol),k_maxx(mol))
               enddo ! mol
c     Debug
c               write(*,*) k_min,k_minT,k_max,k_maxT
c     Debug
c     ----------------------------------------------------------------------
               call analyse_g(band,nk,nu,k,eps1,eps2,k_min,k_max,sit,z,
     &              ns,g_step)

c     production of acceleration arrays "kac" and "gac"
               call acceleration(nk,nu,k,eps1,eps2,Np,k_max,sit,z,
     &              kac,gac)
c     ----------------------------------------------------------------------
c     sensitivities
               call acceleration(nk,nu,kP,eps1,eps2,Np,k_maxP,sit,zP,
     &              kacP,gacP)
               call acceleration(nk,nu,kT,eps1,eps2,Np,k_maxT,sit,zT,
     &              kacT,gacT)
               do mol=1,Nmol
                  do ik=1,kmax
                     kx_tmp(ik)=kx(ik,mol)
                     zx_tmp(ik)=zx(ik,mol)
                  enddo         ! ik
                  call acceleration(nk,nu,kx_tmp,eps1,eps2,Np,
     &                 k_maxx(mol),sit,zx_tmp,kacx_tmp,gacx_tmp)
                  do ik=0,Npmax
                     kacx(ik,mol)=kacx_tmp(ik)
                     gacx(ik,mol)=gacx_tmp(ik)
                  enddo ! ik
c     ----------------------------------------------------------------------
               enddo ! mol
c     Debug
c               do ik=0,Np-1
c                  write(*,*) gac(ik),gacT(ik)
c               enddo
c               stop
c     Debug

c     Inversion of g(i) values
               do quad=1,Nq
                  call g_inversion(i,band,quad,g(quad),Np,gac,kac,
     &                 epsilon,nk,nu,k,eps1,eps2,sit,z,
     &                 kdistp(band,quad),
     &                 delta_kp(band,quad),errp(band,quad))
c     Debug
c                  write(*,*) 'ok0'
c     Debug
c     ----------------------------------------------------------------------
c     sensitivities
                  call g_inversion(i,band,quad,g(quad),Np,gacP,kacP,
     &                 epsilon,nk,nu,kP,eps1,eps2,sit,zP,
     &                 kdistpP(band,quad),
     &                 delta_kpP(band,quad),errpP(band,quad))
c     Debug
c                  write(*,*) 'ok P'
c     Debug
                  call g_inversion(i,band,quad,g(quad),Np,gacT,kacT,
     &                 epsilon,nk,nu,kT,eps1,eps2,sit,zT,
     &                 kdistpT(band,quad),
     &                 delta_kpT(band,quad),errpT(band,quad))
c     Debug
c                  write(*,*) 'ok T'
c     Debug
                  do mol=1,Nmol
                     do ik=0,Npmax
                        kacx_tmp(ik)=kacx(ik,mol)
                        gacx_tmp(ik)=gacx(ik,mol)
                     enddo
                     do ik=1,kmax
                        kx_tmp(ik)=kx(ik,mol)
                        zx_tmp(ik)=zx(ik,mol)
                     enddo      ! ik
                     call g_inversion(i,band,quad,g(quad),Np,
     &                    gacx_tmp,kacx_tmp,
     &                    epsilon,nk,nu,kx_tmp,eps1,eps2,sit,zx_tmp,
     &                    kdistpx(band,quad,mol),
     &                    raf,raf)
                  enddo         ! mol
c     Debug
c                  write(*,*) 'ok x'
c     Debug
c     ----------------------------------------------------------------------
               enddo            ! quad
c     Debug
c               write(*,*) 'band=',band,kdistp(band,1),kdistpx(band,1,1)
c     Debug

               call test_procedure(nk,Nb,Nq,i,band,nu,k,kdistp,w,
     &              tr_exactp(band),tr_quadp(band))

            enddo               ! band

            call MPI_SEND(pindex,1,MPI_INTEGER
     &           ,0,1,MPI_COMM_WORLD,ierr)
            call MPI_SEND(kdistp,Nbmx*Nqmx,MPI_DOUBLE_PRECISION
     &           ,0,1,MPI_COMM_WORLD,ierr)
            call MPI_SEND(delta_kp,Nbmx*Nqmx,MPI_DOUBLE_PRECISION
     &           ,0,1,MPI_COMM_WORLD,ierr)
            call MPI_SEND(errp,Nbmx*Nqmx,MPI_DOUBLE_PRECISION
     &           ,0,1,MPI_COMM_WORLD,ierr)
            call MPI_SEND(tr_exactp,Nbmx,MPI_DOUBLE_PRECISION
     &           ,0,1,MPI_COMM_WORLD,ierr)
            call MPI_SEND(tr_quadp,Nbmx,MPI_DOUBLE_PRECISION
     &           ,0,1,MPI_COMM_WORLD,ierr)
c     ----------------------------------------------------------------------
c     sensitivities
            call MPI_SEND(kdistpP,Nbmx*Nqmx,MPI_DOUBLE_PRECISION
     &           ,0,1,MPI_COMM_WORLD,ierr)
            call MPI_SEND(kdistpT,Nbmx*Nqmx,MPI_DOUBLE_PRECISION
     &           ,0,1,MPI_COMM_WORLD,ierr)
            call MPI_SEND(kdistpx,Nbmx*Nqmx*Nmol_max,
     &           MPI_DOUBLE_PRECISION
     &           ,0,1,MPI_COMM_WORLD,ierr)
            call MPI_SEND(dP,Nbmx,MPI_DOUBLE_PRECISION
     &           ,0,1,MPI_COMM_WORLD,ierr)
            call MPI_SEND(dT,Nbmx,MPI_DOUBLE_PRECISION
     &           ,0,1,MPI_COMM_WORLD,ierr)
            call MPI_SEND(dx,Nbmx*Nmol_max,MPI_DOUBLE_PRECISION
     &           ,0,1,MPI_COMM_WORLD,ierr)
c     ----------------------------------------------------------------------


         endif                  ! codep
         
c     wait for a new execution code
         goto 333
 666     continue
         
      endif                     ! pindex

c     MPICH
      call MPI_FINALIZE(ierr)
c     MPICH

      end
